from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from gso.products.product_blocks.ias_gateway import (
    IASGatewayBlock,
    IASGatewayBlockInactive,
    IASGatewayBlockProvisioning,
)


class IASGatewayInactive(SubscriptionModel, is_base=True):
    ias_gateway: IASGatewayBlockInactive


class IASGatewayProvisioning(IASGatewayInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    ias_gateway: IASGatewayBlockProvisioning


class IASGateway(IASGatewayProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    ias_gateway: IASGatewayBlock
